<template>
  <div>
    <v-skeleton-loader type="article, article" v-if="initialLoader"></v-skeleton-loader>
    <template v-else-if="!initialLoader">
      <v-card-actions>
        <v-col class="text-right">
          <v-btn @click="checkAnswer()"> Check Answers </v-btn>
        </v-col>
      </v-card-actions>
      <v-radio-group v-for="(question, index) in questions" :key="index" :label="question.question"
        v-model="question.selected" :disabled="question.isChecked !== undefined">
        <template v-slot:label>
          <div>{{ index + 1 }}. <strong>{{ question.question }}</strong></div>
        </template>
        <v-radio v-for="(choice, i) in question.choices" :label="choice.value" :value="choice.value" :key="i" :class="(question.selected === choice.value && question.isChecked !== undefined) ?
          (choice.isCorrect ? 'text-green-darken-3' : 'text-red-darken-3') :
          (choice.isCorrect && question.isChecked !== undefined) ? 'text-green-darken-3' : ''">
        </v-radio>
        <span class="font-italic ml-10" ><strong>Explanation:</strong>  {{ question.answer }}</span>
      </v-radio-group>

    </template>
  </div>
</template>

<script>
import { defineComponent, onMounted } from "vue";
import { useTopicStore } from "@/store/topics";
import { ref } from "vue";
import axios from "axios";

export default defineComponent({
  setup() {
    const topic = useTopicStore();
    const questions = ref([]);
    const initialLoader = ref(true)

    const sendChatRequest = async () => {
      const url = "https://api.openai.com/v1/chat/completions";
      const api_key = "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";

      const payload = {
        model: "gpt-3.5-turbo",
        messages: [
          { role: "system", content: "Generate Question" },
          { role: "user", content: "Topic: " + topic.selected.title },
          {
            role: "user",
            content: 'Format: Do not include explanation just json array [{question: "", answer: "", choices: [{value: "", isCorrect: boolean}]}]',
          },
          { role: "user", content: "Type: " + topic.selected.type },
          { role: "user", content: "Number of Question: 5 " },
          { role: "user", content: "Difficulty: " + topic.selected.level },
        ],
      };

      const headers = {
        "Content-Type": "application/json",
        Authorization: `Bearer ${api_key}`,
      };

      try {
        const response = await axios.post(url, payload, { headers });
        const generatedQuestion = response.data.choices[0].message.content;

        const parsedQuestions = JSON.parse(generatedQuestion);
        const formattedQuestions = parsedQuestions.map((q) => ({
          question: q.question,
          answer: q.answer,
          choices: q.choices,
        }));

        questions.value = formattedQuestions;
      } catch (error) {
        console.error(error);
      } finally {
        initialLoader.value = false
      }
    };

    const checkAnswer = () => {
      questions.value.forEach(question => {
        question.isChecked = (question.selected !== undefined) ? true : false
      })
    }

    onMounted(() => {
      sendChatRequest();
    });

    return {
      topic,
      questions,
      initialLoader,
      sendChatRequest,
      checkAnswer

    };
  },
});
</script>
